/* Copyright (c) 2007 Robert Nordier.  All rights reserved. */

#include "lookup.h"

struct mntbl mntbl[] = {
    {"aaa",    0},
    {"aad",    4},
    {"aam",    8},
    {"aas",   12},
    {"adc",   16},
    {"adcb",   17},
    {"adcl",   19},
    {"adcw",   18},
    {"add",   20},
    {"addb",   21},
    {"addl",   23},
    {"addr16",   24},
    {"addr32",   24},
    {"addw",   22},
    {"and",   28},
    {"andb",   29},
    {"andl",   31},
    {"andw",   30},
    {"arpl",   32},
    {"bound",   36},
    {"boundl",   39},
    {"boundw",   38},
    {"bsf",   40},
    {"bsfl",   43},
    {"bsfw",   42},
    {"bsr",   44},
    {"bsrl",   47},
    {"bsrw",   46},
    {"bswap",   48},
    {"bt",   52},
    {"btc",   56},
    {"btcl",   59},
    {"btcw",   58},
    {"btl",   55},
    {"btr",   60},
    {"btrl",   63},
    {"btrw",   62},
    {"bts",   64},
    {"btsl",   67},
    {"btsw",   66},
    {"btw",   54},
    {"call",   68},
    {"cbtw",   72},
    {"cdq",   88},
    {"clc",   76},
    {"cld",   80},
    {"cli",   84},
    {"cltd",   88},
    {"clts",   92},
    {"cmc",   96},
    {"cmova",  100},
    {"cmovae",  128},
    {"cmoval",  103},
    {"cmovaw",  102},
    {"cmovb",  104},
    {"cmovbe",  108},
    {"cmovbel",  111},
    {"cmovbew",  110},
    {"cmovbl",  107},
    {"cmovbw",  106},
    {"cmovc",  104},
    {"cmove",  160},
    {"cmovg",  112},
    {"cmovge",  116},
    {"cmovgel",  119},
    {"cmovgew",  118},
    {"cmovgl",  115},
    {"cmovgw",  114},
    {"cmovl",  120},
    {"cmovle",  124},
    {"cmovlel",  127},
    {"cmovlew",  126},
    {"cmovll",  123},
    {"cmovlw",  122},
    {"cmovna",  108},
    {"cmovnae",  104},
    {"cmovnb",  128},
    {"cmovnbe",  100},
    {"cmovnbl",  131},
    {"cmovnbw",  130},
    {"cmovnc",  128},
    {"cmovne",  140},
    {"cmovng",  124},
    {"cmovnge",  120},
    {"cmovnl",  116},
    {"cmovnle",  112},
    {"cmovno",  132},
    {"cmovnol",  135},
    {"cmovnow",  134},
    {"cmovnp",  152},
    {"cmovns",  136},
    {"cmovnsl",  139},
    {"cmovnsw",  138},
    {"cmovnz",  140},
    {"cmovnzl",  143},
    {"cmovnzw",  142},
    {"cmovo",  144},
    {"cmovol",  147},
    {"cmovow",  146},
    {"cmovp",  148},
    {"cmovpe",  148},
    {"cmovpel",  151},
    {"cmovpew",  150},
    {"cmovpo",  152},
    {"cmovpol",  155},
    {"cmovpow",  154},
    {"cmovs",  156},
    {"cmovsl",  159},
    {"cmovsw",  158},
    {"cmovz",  160},
    {"cmovzl",  163},
    {"cmovzw",  162},
    {"cmp",  164},
    {"cmpb",  165},
    {"cmpl",  167},
    {"cmps",  168},
    {"cmpsb",  169},
    {"cmpsl",  171},
    {"cmpsw",  170},
    {"cmpw",  166},
    {"cmpxchg",  172},
    {"cmpxchg8b",  176},
    {"cmpxchgb",  173},
    {"cmpxchgl",  175},
    {"cmpxchgw",  174},
    {"cpuid",  180},
    {"cs",  184},
    {"cwtd",  188},
    {"cwtl",  192},
    {"daa",  196},
    {"das",  200},
    {"data16",  204},
    {"data32",  204},
    {"dec",  208},
    {"decb",  209},
    {"decl",  211},
    {"decw",  210},
    {"div",  212},
    {"divb",  213},
    {"divl",  215},
    {"divw",  214},
    {"ds",  216},
    {"enter",  220},
    {"es",  224},
    {"f2xm1",  228},
    {"fabs",  232},
    {"fadd",  236},
    {"faddl",  238},
    {"faddp",  240},
    {"fadds",  237},
    {"fbld",  244},
    {"fbstp",  248},
    {"fchs",  252},
    {"fclex",  448},
    {"fcmovb",  256},
    {"fcmovbe",  260},
    {"fcmove",  264},
    {"fcmovnb",  268},
    {"fcmovnbe",  272},
    {"fcmovne",  276},
    {"fcmovnu",  280},
    {"fcmovu",  284},
    {"fcom",  288},
    {"fcomi",  292},
    {"fcomip",  296},
    {"fcoml",  290},
    {"fcomp",  300},
    {"fcompl",  302},
    {"fcompp",  304},
    {"fcomps",  301},
    {"fcoms",  289},
    {"fcos",  308},
    {"fdecstp",  312},
    {"fdiv",  316},
    {"fdivl",  318},
    {"fdivp",  320},
    {"fdivr",  324},
    {"fdivrl",  326},
    {"fdivrp",  328},
    {"fdivrs",  325},
    {"fdivs",  317},
    {"ffree",  332},
    {"ffreep",  336},
    {"fiadd",  340},
    {"fiaddl",  341},
    {"ficom",  344},
    {"ficoml",  345},
    {"ficomp",  348},
    {"ficompl",  349},
    {"fidiv",  352},
    {"fidivl",  353},
    {"fidivr",  356},
    {"fidivrl",  357},
    {"fild",  360},
    {"fildl",  361},
    {"fildll",  364},
    {"fimul",  368},
    {"fimull",  369},
    {"fincstp",  372},
    {"finit",  452},
    {"fist",  376},
    {"fistl",  377},
    {"fistp",  380},
    {"fistpl",  381},
    {"fistpll",  384},
    {"fisub",  388},
    {"fisubl",  389},
    {"fisubr",  392},
    {"fisubrl",  393},
    {"fld",  396},
    {"fld1",  400},
    {"fldcw",  404},
    {"fldenv",  408},
    {"fldl",  398},
    {"fldl2e",  412},
    {"fldl2t",  416},
    {"fldlg2",  420},
    {"fldln2",  424},
    {"fldpi",  428},
    {"flds",  397},
    {"fldt",  432},
    {"fldz",  436},
    {"fmul",  440},
    {"fmull",  442},
    {"fmulp",  444},
    {"fmuls",  441},
    {"fnclex",  448},
    {"fninit",  452},
    {"fnop",  456},
    {"fnsave",  460},
    {"fnstcw",  464},
    {"fnstenv",  468},
    {"fnstsw",  472},
    {"fpatan",  476},
    {"fprem",  480},
    {"fprem1",  484},
    {"fptan",  488},
    {"frndint",  492},
    {"frstor",  496},
    {"fs",  500},
    {"fsave",  460},
    {"fscale",  504},
    {"fsin",  508},
    {"fsincos",  512},
    {"fsqrt",  516},
    {"fst",  520},
    {"fstcw",  464},
    {"fstenv",  468},
    {"fstl",  522},
    {"fstp",  524},
    {"fstpl",  526},
    {"fstps",  525},
    {"fstpt",  528},
    {"fsts",  521},
    {"fstsw",  472},
    {"fsub",  532},
    {"fsubl",  534},
    {"fsubp",  536},
    {"fsubr",  540},
    {"fsubrl",  542},
    {"fsubrp",  544},
    {"fsubrs",  541},
    {"fsubs",  533},
    {"ftst",  548},
    {"fucom",  552},
    {"fucomi",  556},
    {"fucomip",  560},
    {"fucomp",  564},
    {"fucompp",  568},
    {"fwait", 1088},
    {"fxam",  572},
    {"fxch",  576},
    {"fxtract",  580},
    {"fyl2x",  584},
    {"fyl2xp1",  588},
    {"gs",  592},
    {"hlt",  596},
    {"idiv",  600},
    {"idivb",  601},
    {"idivl",  603},
    {"idivw",  602},
    {"imul",  604},
    {"imulb",  605},
    {"imull",  607},
    {"imulw",  606},
    {"in",  608},
    {"inb",  609},
    {"inc",  612},
    {"incb",  613},
    {"incl",  615},
    {"incw",  614},
    {"inl",  611},
    {"ins",  616},
    {"insb",  617},
    {"insl",  619},
    {"insw",  618},
    {"int",  620},
    {"int3",  624},
    {"into",  628},
    {"invd",  632},
    {"invlpg",  636},
    {"inw",  610},
    {"iret",  640},
    {"iretl",  643},
    {"iretw",  642},
    {"ja",  644},
    {"jae",  684},
    {"jb",  648},
    {"jbe",  652},
    {"jc",  648},
    {"jcxz",  656},
    {"je",  716},
    {"jecxz",  660},
    {"jg",  664},
    {"jge",  668},
    {"jl",  672},
    {"jle",  676},
    {"jmp",  680},
    {"jna",  652},
    {"jnae",  648},
    {"jnb",  684},
    {"jnbe",  644},
    {"jnc",  684},
    {"jne",  696},
    {"jng",  676},
    {"jnge",  672},
    {"jnl",  668},
    {"jnle",  664},
    {"jno",  688},
    {"jnp",  708},
    {"jns",  692},
    {"jnz",  696},
    {"jo",  700},
    {"jp",  704},
    {"jpe",  704},
    {"jpo",  708},
    {"js",  712},
    {"jz",  716},
    {"lahf",  720},
    {"lar",  724},
    {"larl",  727},
    {"larw",  726},
    {"lcall",  728},
    {"lcalll",  731},
    {"lcallw",  730},
    {"lds",  732},
    {"ldsl",  735},
    {"ldsw",  734},
    {"lea",  736},
    {"leal",  739},
    {"leave",  740},
    {"leaw",  738},
    {"les",  744},
    {"lesl",  747},
    {"lesw",  746},
    {"lfs",  748},
    {"lfsl",  751},
    {"lfsw",  750},
    {"lgdt",  752},
    {"lgs",  756},
    {"lgsl",  759},
    {"lgsw",  758},
    {"lidt",  760},
    {"ljmp",  764},
    {"ljmpl",  767},
    {"ljmpw",  766},
    {"lldt",  768},
    {"lmsw",  772},
    {"lock",  776},
    {"lods",  780},
    {"lodsb",  781},
    {"lodsl",  783},
    {"lodsw",  782},
    {"loop",  784},
    {"loope",  792},
    {"loopne",  788},
    {"loopnz",  788},
    {"loopz",  792},
    {"lret",  796},
    {"lsl",  800},
    {"lsll",  803},
    {"lslw",  802},
    {"lss",  804},
    {"lssl",  807},
    {"lssw",  806},
    {"ltr",  808},
    {"mov",  812},
    {"movb",  813},
    {"movl",  815},
    {"movs",  816},
    {"movsb",  817},
    {"movsbl",  823},
    {"movsbw",  822},
    {"movsl",  819},
    {"movsw",  818},
    {"movswl",  827},
    {"movw",  814},
    {"movzb",  828},
    {"movzbl",  831},
    {"movzbw",  830},
    {"movzw",  832},
    {"movzwl",  835},
    {"mul",  836},
    {"mulb",  837},
    {"mull",  839},
    {"mulw",  838},
    {"neg",  840},
    {"negb",  841},
    {"negl",  843},
    {"negw",  842},
    {"nop",  844},
    {"not",  848},
    {"notb",  849},
    {"notl",  851},
    {"notw",  850},
    {"or",  852},
    {"orb",  853},
    {"orl",  855},
    {"orw",  854},
    {"out",  856},
    {"outb",  857},
    {"outl",  859},
    {"outs",  860},
    {"outsb",  861},
    {"outsl",  863},
    {"outsw",  862},
    {"outw",  858},
    {"pop",  864},
    {"popa",  868},
    {"popal",  871},
    {"popaw",  870},
    {"popf",  872},
    {"popfl",  875},
    {"popfw",  874},
    {"popl",  867},
    {"popw",  866},
    {"push",  876},
    {"pusha",  880},
    {"pushal",  883},
    {"pushaw",  882},
    {"pushf",  884},
    {"pushfl",  887},
    {"pushfw",  886},
    {"pushl",  879},
    {"pushw",  878},
    {"rcl",  888},
    {"rclb",  889},
    {"rcll",  891},
    {"rclw",  890},
    {"rcr",  892},
    {"rcrb",  893},
    {"rcrl",  895},
    {"rcrw",  894},
    {"rdmsr",  896},
    {"rdpmc",  900},
    {"rdtsc",  904},
    {"rep",  912},
    {"repe",  912},
    {"repne",  908},
    {"repnz",  908},
    {"repz",  912},
    {"ret",  916},
    {"rol",  920},
    {"rolb",  921},
    {"roll",  923},
    {"rolw",  922},
    {"ror",  924},
    {"rorb",  925},
    {"rorl",  927},
    {"rorw",  926},
    {"rsm",  928},
    {"sahf",  932},
    {"sal", 1016},
    {"salb", 1017},
    {"sall", 1019},
    {"salw", 1018},
    {"sar",  936},
    {"sarb",  937},
    {"sarl",  939},
    {"sarw",  938},
    {"sbb",  940},
    {"sbbb",  941},
    {"sbbl",  943},
    {"sbbw",  942},
    {"scas",  944},
    {"scasb",  945},
    {"scasl",  947},
    {"scasw",  946},
    {"seta",  948},
    {"setae",  976},
    {"setb",  952},
    {"setbe",  956},
    {"setc",  952},
    {"sete", 1008},
    {"setg",  960},
    {"setge",  964},
    {"setl",  968},
    {"setle",  972},
    {"setna",  956},
    {"setnae",  952},
    {"setnb",  976},
    {"setnbe",  948},
    {"setnc",  976},
    {"setne",  988},
    {"setng",  972},
    {"setnge",  968},
    {"setnl",  964},
    {"setnle",  960},
    {"setno",  980},
    {"setnp", 1000},
    {"setns",  984},
    {"setnz",  988},
    {"seto",  992},
    {"setp",  996},
    {"setpe",  996},
    {"setpo", 1000},
    {"sets", 1004},
    {"setz", 1008},
    {"sgdt", 1012},
    {"shl", 1016},
    {"shlb", 1017},
    {"shld", 1020},
    {"shldl", 1023},
    {"shldw", 1022},
    {"shll", 1019},
    {"shlw", 1018},
    {"shr", 1024},
    {"shrb", 1025},
    {"shrd", 1028},
    {"shrdl", 1031},
    {"shrdw", 1030},
    {"shrl", 1027},
    {"shrw", 1026},
    {"sidt", 1032},
    {"sldt", 1036},
    {"smsw", 1040},
    {"ss", 1044},
    {"stc", 1048},
    {"std", 1052},
    {"sti", 1056},
    {"stos", 1060},
    {"stosb", 1061},
    {"stosl", 1063},
    {"stosw", 1062},
    {"str", 1064},
    {"sub", 1068},
    {"subb", 1069},
    {"subl", 1071},
    {"subw", 1070},
    {"test", 1072},
    {"testb", 1073},
    {"testl", 1075},
    {"testw", 1074},
    {"ud2", 1076},
    {"verr", 1080},
    {"verw", 1084},
    {"wait", 1088},
    {"wbinvd", 1092},
    {"wrmsr", 1096},
    {"xadd", 1100},
    {"xaddb", 1101},
    {"xaddl", 1103},
    {"xaddw", 1102},
    {"xchg", 1104},
    {"xchgb", 1105},
    {"xchgl", 1107},
    {"xchgw", 1106},
    {"xlat", 1108},
    {"xlatb", 1109},
    {"xor", 1112},
    {"xorb", 1113},
    {"xorl", 1115},
    {"xorw", 1114},
};

unsigned mnnum = 573;
